classdef InputRestrictions
   properties(Constant)
        INT_g1  = 1;
        INT_g0  = 2;
        INT_ge0 = 3;
        INT     = 4
        POS     = 5;
        POS_0   = 6;
        NUM     = 7;
        CAT     = 8;
        VECTOR  = 9;
        IGNORE  = 10;
        BOOL = 11;
        
        VALIDATOR = { ...
        @(x) (floor(x) == x) && (x > 1)       , ... %INT_g1
        @(x) (floor(x) == x) && (x > 0)       , ... %INT_g0
        @(x) (floor(x) == x) && (x >= 0)      , ... %INT_ge0
        @(x) (floor(x) == x)                  , ... %INT
        @(x) (x > 0)                          , ... %POS
        @(x) (x >= 0)                         , ... %POS_0
        @(x) true                             , ... %NUM 
        @(x) false                            , ... %CAT
        @(x) isvector(x)                      , ... %VECTOR
        @(x) false                            , ... %IGNORE
        @(x) (x == 0) || (x == 1)             }     %BOOL

        ADJUSTER = { ...      
        @(x) floor(x) , ...  %INT_g1
        @(x) floor(x) , ...  %INT_g0
        @(x) floor(x) , ...  %INT_ge0
        @(x) floor(x) , ...  %INT
        @(x) x , ...          %POS
        @(x) x , ...          %POS_0
        @(x) x , ...          %NUM
        @(x) x , ...          %CAT
        @(x) x , ...          %VECTOR
        @(x) 0 , ...          %IGNORE
        @(x) x~=0 }           %BOOL       
   end

   methods(Static)
       
       function b = isNumerical(numcode)
           b = numcode < 8;  %ok for: INT_xx and POS_xx and NUM. not ok for CAT
       end
   end
 
   
end